# -*- coding: UTF-8 -*-

# word2word-litdeu-0.1
# Copyright (c) 2006 Kęstutis Biliūnas <kebil@kaunas.init.lt>
#
# This code is licensed under the GNU GPL v2

"""
OpenDict plugin for online word2word dictionary
(www.lietuviu-vokieciu.com)
"""

import sys
import re
import httplib
import urllib
import socket

#import sets
#import HTMLParser

def init(libraryPath):
    """Return dictionary instance"""

    sys.path.insert(0, libraryPath)

    return Word2word_litdeu()


class Word2word_litdeu:
    """Word2word plugin class"""
    
    def __init__(self):
        """Initialize variables"""

        from lib import errortype, meta

        self.errorModule = errortype
        self.metaModule = meta

        self.encoding = "utf-8"

        self.needsList = 0


    def search(self, word):
        """Search for a word. Returns HTML code."""

        result = self.metaModule.SearchResult()

        try:
            self.conn = httplib.HTTPConnection("www.lietuviu-vokieciu.com")
            self.conn.request("GET", "/?word="+urllib.quote(word))

            response = self.conn.getresponse()
            data = response.read()

            if "Nėra vertimo" in data:
                zodz = 0
            else:
                if "papildyti" in data:
                    zodz = 2
                else:
                    zodz = 1

            end = data.find('<center><span style=\"font-size:0.8em\">draugai:')
            data = data[:end]

            end = data.find('</td></tr></table>')
            data = data[:end]

            # Fix links
            href = re.compile('<a href.*?>.*?</a>')
            for link in href.findall(data):
                dest = link[9:link.find('">')]
                name = link[link.find('">')+2:link.find('</a>')]
                newlink = link.replace(dest, name.strip())
                data = data.replace(link, newlink)


            header = "<html><head>" \
                   "<meta http-equiv=\"Content-Type\" " \
                   "content=\"text/html; charset=utf-8\">" \
                   "</head><body>"

            if zodz == 0:
                data = header + "Nėra vertimo"		

            if zodz == 1:
                data = data[data.find("<h2>"+word+"</h2>"):]
                data = header + data.strip()

                data = data.replace("<h2>", "<b>")
                data = data.replace("</h2>", "</b>")

                data = data.replace(";", ";<br>\n")
                data = data.replace("</a>", "")

            if zodz == 2:
                data = data[data.find("</a>]</div>"):]
                data = data.replace("</a>]</div>", "")
                data = header + data.strip()
                data = data + "</td></tr></table>"

            data = data + "</body></html>"
            result.setTranslation(data)

        except socket.gaierror, e:
            result.setError(self.errorModule.CONNECTION_ERROR)
            return result
        
        except httplib.CannotSendRequest, e:
            result.setError(self.errorModule.CONNECTION_ERROR)
            return result

        except:
            import traceback
            traceback.print_exc()

            result.setError(self.errorModule.INTERNAL_ERROR)

            return result

        return result
